addHook("MobjThinker", function(mobj)
	local player = mobj.player
	if (player.mo and player.mo.skin == "orange")
		
	// Bounce Attack
		if player.rebound and player.mo.state == S_PLAY_SPRING then
           P_SetObjectMomZ(player.mo, 28*FRACUNIT)
		   S_StartSound(player.mo, sfx_sprong)
        end
		
		if(player.pflags & PF_JUMPED)
			and(player.cmd.buttons & BT_SPIN)
			and not(player.prevspin)
			and not player.atwall
			and not player.powers[pw_super]
				P_SetObjectMomZ(player.mo, -26*FRACUNIT, false)
				player.pflags = $1|PF_THOKKED
				player.rebound = true
				player.mo.state = S_PLAY_ROLL
			end
				
			if(player.rebound)
			and(P_IsObjectOnGround(player.mo))
				P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
				player.pflags = $1|PF_JUMPED 
				player.rebound = false
				player.mo.state = S_PLAY_ROLL
				S_StartSound(player.mo, sfx_bnce2)
			end
				
			if(player.rebound)
				if not(player.pflags & PF_JUMPED)
					player.rebound = false
				end
			end
			
			
				
			player.prevspin = player.cmd.buttons & BT_SPIN
			
			
	end
end, MT_PLAYER)
           
addHook("ThinkFrame", do
	for player in players.iterate
		if not player.mo return end 
		if player.mo.skin == "orange"
			if (player.pflags & PF_JUMPED)
			and not player.cling
			end
		end
	end
end)




local function SpawnWallDust(mo)
local dust = P_SpawnMobj(mo.x, mo.y, mo.z + ((mo.eflags & MFE_VERTICALFLIP)/MFE_VERTICALFLIP * (mo.height - mobjinfo[MT_SPINDUST].height)) + mo.player.spinheight, MT_SPINDUST)
	if mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER)
	dust.state = S_SPINDUST_BUBBLE1
	end
P_Thrust(dust, mo.angle + (P_RandomRange(-25, 25)*ANG1), P_RandomRange(10,30)*FRACUNIT)
dust.momz = P_RandomRange(5,8)*FRACUNIT
	if (leveltime % 6) == 5
	S_StartSound(mo, sfx_s3k7e)
	end
dust.eflags = $1|(mo.eflags & MFE_VERTICALFLIP)
dust.scale = mo.scale * 3/4
dust.flags = $1 & ~(MF_NOCLIP|MF_NOCLIPHEIGHT)
dust.flags = $1|MF_SLIDEME
end

//Run EFFECT XDDDDDDD
addHook ("PlayerThink",function(player)
if player.mo.skin == "orange"
	if (P_IsObjectOnGround(player.mo)) 
	and (player.mo.state == S_PLAY_RUN) 
	or (player.mo.state == S_PLAY_DASH)
	and not player.powers[pw_super]
		P_SpawnSkidDust(player, 15*FRACUNIT, sfx_none)
	end
end
end)
